//---------- Functions to call when you only have a VisibleObject* -------

VECTOR ObjectNormal(VISIBLEOBJECT *O, RPOINT *P)
{
  switch (O->Type){
    case OBJECT_SPHERE:
	    return SphereNormal((SPHERE*)O, P);

    case OBJECT_PLANE:
	    return PlaneNormal((PLANE*)O, P);
  }

   // Stop "Function should return a value" warning.

    VECTOR Temp = {0,0,0};
  	return Temp;

}

void ObjectGetPixel(VISIBLEOBJECT *O, RPOINT *P, COLOR *C)
{

  switch (O->Type)
  {
    case OBJECT_SPHERE:
	   *C = O->OpticalProperty.Col;
	   break;

    case OBJECT_PLANE:
       PlaneGetPixel((PLANE*)O, P, C);
	   break;

  }
}

bool ObjectIntersect(VISIBLEOBJECT *O, void *R)
{
  switch (O->Type)
  {
    case OBJECT_SPHERE:
	    return SphereIntersect((SPHERE*)O, (RAY*)R);

    case OBJECT_PLANE:
		return PlaneIntersect((PLANE*)O, (RAY*)R);
  }
  return 0;
}

void *ObjectCreateShader(VISIBLEOBJECT *O, void *R)
{
  switch (O->Type)
  {
    case OBJECT_SPHERE:
	    return SphereCreateShader((SPHERE*)O, (RAY*)R);

    case OBJECT_PLANE:
		return PlaneCreateShader((PLANE*)O, (RAY*)R);
  }
  return NULL;
}
