#if !defined OBJECT_H
#define OBJECT_H
//------------------------------------
//  (c) Reliable Software, 1996, 97
//------------------------------------

// Optical properties of a VisibleObject
typedef struct{
  COLOR  Col;

  double Refractiveness; // Coefficient of refraction
  double Transparency;   // Transparency
  double Reflectiveness; // Reflection
  double Diffusion;      // Diffuse coeff

  bool   IsLuminous;
}OPTICALPROP;

// Common to all objects
typedef struct{
  int Type;
  OPTICALPROP OpticalProperty;
}VISIBLEOBJECT;

VECTOR ObjectNormal(VISIBLEOBJECT *,RPOINT *);
void ObjectGetPixel(VISIBLEOBJECT *,RPOINT *,COLOR *);
bool ObjectIntersect(VISIBLEOBJECT *,void *);
void *ObjectCreateShader(VISIBLEOBJECT *,void *);

//
//-------------------- SPHERE ---------------------
//
#define OBJECT_SPHERE 1

typedef struct{
  VISIBLEOBJECT Obj;
  RPOINT  Center;
  double Radius;
  double R2; // Radius square
}SPHERE;

//
//-------------------- PLANE ---------------------
//
#define OBJECT_PLANE 2

typedef struct{
  VISIBLEOBJECT Obj;
  RPOINT  Center;
  VECTOR Normal;

  // The tile
  COLORREF *Pixels;
  int       Width;
  int       Height;

  double    Cos_inv;
}PLANE;

#endif
