#if !defined RAY_H
#define RAY_H
//------------------------------------
//  (c) Reliable Software, 1996, 97
//------------------------------------
const double HUGE_DIST = 1000000.0;

typedef enum{ rtNormal = 1,rtRefracted,rtShadow }RAYTYPE;

typedef struct{
  RAYTYPE Type;
  RPOINT Origin;
  VECTOR Direction;
  int Depth;
  double Dist;
  VISIBLEOBJECT *Obj;

  //For rtRefacted
  double Refr;

  //For rtShadow
  double Attenuation; // Attenuation when passing through transparent objects
}RAY,*LPRAY;

void RaySet(RAY *,RAYTYPE,RPOINT *,VECTOR *,int,double);
void RayHit(RAY *,COLOR *);
RPOINT RayIntersect(RAY *);
void RayRecord(RAY *,double,VISIBLEOBJECT *);
void RayDoShade(RAY *,COLOR *);

#endif
