#if !defined SHADER_H
#define SHADER_H
//------------------------------------
//  (c) Reliable Software, 1996, 97
//------------------------------------
#define SHADER_PHONG 1

// Plane Shader - Creates stripes
#define SHADER_PLANE 2

typedef struct{
  int Type;
  RAY *IncidentRay;
  OPTICALPROP *Prop;
  int Depth;

  // Secondary rays
  RAY *ReflectedRay;
  RAY *RefractedRay;
  RAY *ShadowRay;

  // Geometry
  RPOINT  Intersect;
  VECTOR Normal;
  double Cosine;
  double Light_cos;

  // Plane shader only
  COLOR Pixel;
}Shader;

void ShaderSet(Shader*,int,RAY*,VISIBLEOBJECT*);
void ShaderGetColor(Shader*,COLOR*);
VECTOR ShaderReflect(Shader*);
VECTOR ShaderRefract(Shader*);
void ShaderFree(Shader*);

#endif
